# KeyManager API

For details on how to use key_management, see Using OpenStack Key Manager

## The KeyManager Class

The key_management high-level interface is available through the `key_manager` member of a `Connection` object. The `key_manager` member will only be added if the service is detected.

### Secret Operations

class openstack.key_manager.v1._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_secret(**attrs)

    Create a new secret from attributes

    Parameters:

      attrs (dict) – Keyword arguments which will be used to create a `Secret`, comprised of the properties on the Order class.

    Returns:

      The results of secret creation

    Return type:

      `Secret`

  delete_secret(secret, ignore_missing=True)

    Delete a secret

    Parameters:

      - secret – The value can be either the ID of a secret or a `Secret` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the secret does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent secret.

    Returns:

      `None`

  find_secret(name_or_id, ignore_missing=True)

    Find a single secret

    Parameters:

      - name_or_id – The name or ID of a secret.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

    Returns:

      One `Secret` or None

  get_secret(secret)

    Get a single secret

    Parameters:

      secret – The value can be the ID of a secret or a `Secret` instance.

    Returns:

      One `Secret`

    Raises:

      `NotFoundException` when no resource can be found.

  secrets(**query)

    Return a generator of secrets

    Parameters:

      query (kwargs) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of secret objects

    Return type:

      `Secret`

  update_secret(secret, **attrs)

    Update a secret

    Parameters:

      - secret – Either the id of a secret or a `Secret` instance.

      - attrs – The attributes to update on the secret represented by `secret`.

    Returns:

      The updated secret

    Return type:

      `Secret`

### Container Operations

class openstack.key_manager.v1._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_container(**attrs)

    Create a new container from attributes

    Parameters:

      attrs (dict) – Keyword arguments which will be used to create a `Container`, comprised of the properties on the Container class.

    Returns:

      The results of container creation

    Return type:

      `Container`

  delete_container(container, ignore_missing=True)

    Delete a container

    Parameters:

      - container – The value can be either the ID of a container or a `Container` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the container does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent container.

    Returns:

      `None`

  find_container(name_or_id, ignore_missing=True)

    Find a single container

    Parameters:

      - name_or_id – The name or ID of a container.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

    Returns:

      One `Container` or None

  get_container(container)

    Get a single container

    Parameters:

      container – The value can be the ID of a container or a `Container` instance.

    Returns:

      One `Container`

    Raises:

      `NotFoundException` when no resource can be found.

  containers(**query)

    Return a generator of containers

    Parameters:

      query (kwargs) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of container objects

    Return type:

      `Container`

  update_container(container, **attrs)

    Update a container

    Parameters:

      - container – Either the id of a container or a `Container` instance.

      - attrs – The attributes to update on the container represented by `container`.

    Returns:

      The updated container

    Return type:

      `Container`

### Order Operations

class openstack.key_manager.v1._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_order(**attrs)

    Create a new order from attributes

    Parameters:

      attrs (dict) – Keyword arguments which will be used to create a `Order`, comprised of the properties on the Order class.

    Returns:

      The results of order creation

    Return type:

      `Order`

  delete_order(order, ignore_missing=True)

    Delete an order

    Parameters:

      - order – The value can be either the ID of a order or a `Order` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the order does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent order.

    Returns:

      `None`

  find_order(name_or_id, ignore_missing=True)

    Find a single order

    Parameters:

      - name_or_id – The name or ID of a order.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

    Returns:

      One `Order` or None

  get_order(order)

    Get a single order

    Parameters:

      order – The value can be the ID of an order or a `Order` instance.

    Returns:

      One `Order`

    Raises:

      `NotFoundException` when no resource can be found.

  orders(**query)

    Return a generator of orders

    Parameters:

      query (kwargs) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of order objects

    Return type:

      `Order`

  update_order(order, **attrs)

    Update a order

    Parameters:

      - order – Either the id of a order or a `Order` instance.

      - attrs – The attributes to update on the order represented by `order`.

    Returns:

      The updated order

    Return type:

      `Order`

### Secret Store Operations

class openstack.key_manager.v1._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  secret_stores(**query)

    Return a generator of secret stores

    Parameters:

      query (kwargs) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of secret store objects

    Return type:

      `SecretStore`

  get_global_default_secret_store()

    Get the global default secret store

    Returns:

      One `SecretStore`

    Raises:

      `NotFoundException` when no resource can be found.

  get_preferred_secret_store()

    Get the preferred secret store for the current project

    Returns:

      One `SecretStore`

    Raises:

      `NotFoundException` when no resource can be found.

this page last updated: 2026-01-16 23:06:19

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.